(*
   CS 31600
   Assignment 6
   Solutions

   From pages 144-147 of the textbook.
*)

(* Exercise 4 *)

fun multpairs pairList = map op * pairList;

val multpairs = map op *;


(* Exerices 5 *)

fun inclist intList i = map (fn n => n+i) intList;


(* Exercise 6 *)

fun sqsum intList = foldl (op +) 0 (map (fn x => x*x) intList);

fun sqsum intList = foldl (fn (n,result) => n*n + result) 0 intList;

val sqsum = foldl (fn (n,result) => n*n + result) 0;


(* Exercise 10 *)

fun dupList anyList = foldr (fn (x, result) => x::x::result) [] anyList;

fun dupList anyList = foldl (fn (x, result) => result@[x,x]) [] anyList;
(* NOTE: the following doesn't work because [] is so weird *)
val dupList = foldr (fn (x, result) => x::x::result) [];


(* Exercise 14 *)

fun maxpairs pairList = foldr (fn ((a,b),xs) => if a>b then a::xs else b::xs) [] pairList;

fun maxpairs pairList = foldl (fn ((a,b),xs) => if a>b then xs@[a] else xs@[b]) [] pairList;

val maxpairs = map (fn (a,b)=>if a>b then a else b);


(* Exercise 15 *)

val myimplode = foldl (fn (a,result) => result ^ str a) "";

val myimplode = foldr (fn (a,result) => str a ^ result) "";

fun myimplode charList = foldr (op ^) "" (map str charList);

val myimplode = foldr ((op ^)o(fn(a,b)=>(str a, b))) "";

val myimplode = (foldr (op ^) "") o (map str);


(* Exercise 16 *)

fun lconcat listList = foldr (op @) nil listList;

fun lconcat listList = foldl (fn(a,result)=>result@a) nil listList;
(* NOTE: the following doesn't work because nil is so weird. *)
val lconcat = foldr (op @) nil;

(* without using @ *)
fun lconcat listList = foldr (fn (a,b) => foldr (op ::) b a) nil listList;


(* Exercise 21 *)

fun less (i, intList) = foldr (fn (a, result) => if a<i then a::result else result) [] intList;

fun less (i, intList) = foldr (op @) [] (map (fn a => if a<i then [a] else []) intList);


(* Exercise 23 *)

fun convert pairList = foldr (fn ((a,b), (aList,bList)) => (a::aList, b::bList)) (nil, nil) pairList;
(* the following is probably not a good idea, since it traverses the input list twice *)
fun convert pairList = ( foldr (fn ((a,_),aList) => a::aList) [] pairList,
                         foldr (fn ((_,b),bList) => b::bList) [] pairList );


(* Exercise 24 *)

fun mymap f aList = foldr (fn (a,b) => f(a)::b) [] aList;
(* compare the following with the unsuccessful definitions in 10 and 16 *)
fun mymap f = foldr (fn (a,b) => f(a)::b) [];


(* Exercise 26 *)

fun mymap2 _ [] = []
 |  mymap2 f (x::xs) = f(x)::(mymap f xs);

val rec mymap2 = fn f => fn y =>
  case y of
      [] => []
   |  (x::xs) => f(x)::(mymap2 f xs);


(* Exercise 27 *)

fun myfoldr _ a [] = a
 |  myfoldr f a (x::xs) = f(x, myfoldr f a xs);

val rec myfoldr = fn f => fn a => fn y =>
  case y of
      [] => a
   |  (x::xs) => f(x, myfoldr f a xs);

val rec myfoldr = fn f => fn a => fn [] => a | (x::xs) => f(x, myfoldr f a xs);